<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<div class="domains-tab-wrapper">

		<FiltersTop> 
			<button class="button button-secondary orange rounded" v-if="isPage" @click="showCreateDomainModal = true">
				New Domain
			</button>
			<button class="button button-stroke-transparent" v-if="isPage">
				Import Domain
			</button>
			<button class="button button-stroke-transparent" v-if="!isPage" @click="showCreateDomainModal = true">
				Add Domain
			</button>
			<div class="filters-top-totals"><b>{{ domains?.length }} Domain(s)</b> related to this dataset</div>
		</FiltersTop>
		<div class="domains-wrapper">
			<div class="row">
				<div v-for="domain in domains" class="col-xl-4 col-lg-4">
					<CardsCardFolder :domain="domain" @click="goDetails($event, domain.name)" />
				</div>
			</div>
		</div>

		<ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateDomain v-if="showCreateDomainModal" @toggle="close" />
            </Teleport>
        </ClientOnly>
	</div>
</template>

<script setup lang="ts">
import FiltersTop from './FiltersTop.vue';

const props = defineProps({
    isPage: { 
        type: Boolean, 
		default: false,
        required: false 
    },
    domainData: {
        type: Object,
        required: false,
		default: () => ({ domains: [] })
    }
});

const emit = defineEmits(['refresh-data']);

const domains = ref(props.domainData);

watch(
  () => props.domainData,
  (newData) => {
    if (newData && newData.domains) {
      domains.value = newData.domains;
    }
  },
  { immediate: true }
);

const sortOptions = ref(['Last modified first', 'Last modified last', 'Option 3']);

const goDetails = (event: Event, id: number) => {
	event.preventDefault();
	console.log(id);
	navigateTo('/domains/' + id);
}

const showCreateDomainModal = ref(false);

const close = () => {
    showCreateDomainModal.value = false;
	emit('refresh-data');
};

</script>